VTK: vtkOBBTree Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkOBBTree Class Reference

generate oriented bounding box (OBB) tree More...

`#include <vtkOBBTree.h>`

Inheritance diagram for vtkOBBTree:
[legend]
Collaboration diagram for vtkOBBTree:
[legend]

## Public Member Functions
int | IntersectWithLine (const double a0[3], const double a1[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell) override
| Return the first intersection of the specified line segment with the OBB tree, as well as information about the cell which the line segment intersected. More...
int | IntersectWithLine (const double a0[3], const double a1[3], vtkPoints *points, vtkIdList *cellIds) override
| Take the passed line segment and intersect it with the data set. More...
void | ComputeOBB (vtkDataSet *input, double corner[3], double max[3], double mid[3], double min[3], double size[3])
| Compute an OBB for the input dataset using the cells in the data. More...
int | InsideOrOutside (const double point[3])
| Determine whether a point is inside or outside the data used to build this OBB tree. More...
int | DisjointOBBNodes (vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *XformBtoA)
| Returns true if nodeB and nodeA are disjoint after optional transformation of nodeB with matrix XformBtoA. More...
int | LineIntersectsNode (vtkOBBNode *pA, const double b0[3], const double b1[3])
| Returns true if line intersects node. More...
int | TriangleIntersectsNode (vtkOBBNode *pA, double p0[3], double p1[3], double p2[3], vtkMatrix4x4 *XformBtoA)
| Returns true if triangle (optionally transformed) intersects node. More...
int | IntersectWithOBBTree (vtkOBBTree *OBBTreeB, vtkMatrix4x4 *XformBtoA, int(*function)(vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *Xform, void *arg), void *data_arg)
| For each intersecting leaf node pair, call function. More...
void | GenerateRepresentation (int level, vtkPolyData *pd) override
| Create polygonal representation for OBB tree at specified level. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId)
| Return intersection point (if any) of finite line with cells contained in cell locator. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId, vtkGenericCell *cell)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell)
| Take the passed line segment and intersect it with the data set. More...
void | FreeSearchStructure () override
| Satisfy locator's abstract interface, see vtkLocator. More...
void | BuildLocator () override
| Satisfy locator's abstract interface, see vtkLocator. More...
void | ForceBuildLocator () override
| Satisfy locator's abstract interface, see vtkLocator. More...
Public Member Functions inherited from vtkAbstractCellLocator
vtkAbstractCellLocator * | NewInstance () const
void | ComputeCellBounds ()
| This function can be used either internally or externally to compute only the cached cell bounds if CacheCellBounds is on. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId)
| Return intersection point (if any) of finite line with cells contained in cell locator. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId, vtkIdType &cellId)
| Return intersection point (if any) AND the cell which was intersected by the finite line. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds)
| Take the passed line segment and intersect it with the data set. More...
virtual int | IntersectWithLine (const double p1[3], const double p2[3], double tol, vtkPoints *points, vtkIdList *cellIds, vtkGenericCell *cell)
| Take the passed line segment and intersect it with the data set. More...
virtual void | FindClosestPoint (const double x[3], double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point and the cell which is closest to the point x. More...
virtual void | FindClosestPoint (const double x[3], double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2, int &inside)
| Return the closest point within a specified radius and the cell which is closest to the point x. More...
virtual void | FindCellsWithinBounds (double *bbox, vtkIdList *cells)
| Return a list of unique cell ids inside of a given bounding box. More...
virtual void | FindCellsAlongLine (const double p1[3], const double p2[3], double tolerance, vtkIdList *cells)
| Take the passed line segment and intersect it with the data set. More...
virtual void | FindCellsAlongPlane (const double o[3], const double n[3], double tolerance, vtkIdList *cells)
| Given an unbounded plane defined by an origin o[3] and unit normal n[3], return the list of unique cell ids in the buckets containing the plane. More...
virtual vtkIdType | FindCell (double x[3])
| Returns the Id of the cell containing the point, returns -1 if no cell found. More...
virtual bool | InsideCellBounds (double x[3], vtkIdType cell_ID)
| Quickly test if a point is inside the bounds of a particular cell. More...
virtual void | ShallowCopy (vtkAbstractCellLocator *)
| Shallow copy of a vtkAbstractCellLocator. More...
virtual void | SetNumberOfCellsPerNode (int)
| Specify the preferred/maximum number of cells in each node/bucket. More...
virtual int | GetNumberOfCellsPerNode ()
| Specify the preferred/maximum number of cells in each node/bucket. More...
virtual void | SetCacheCellBounds (vtkTypeBool)
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual vtkTypeBool | GetCacheCellBounds ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | CacheCellBoundsOn ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | CacheCellBoundsOff ()
| Boolean controls whether the bounds of each cell are computed only once and then saved. More...
virtual void | SetRetainCellLists (vtkTypeBool)
| Boolean controls whether to maintain list of cells in each node. More...
virtual vtkTypeBool | GetRetainCellLists ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | RetainCellListsOn ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | RetainCellListsOff ()
| Boolean controls whether to maintain list of cells in each node. More...
virtual void | SetLazyEvaluation (vtkTypeBool)
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual vtkTypeBool | GetLazyEvaluation ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual void | LazyEvaluationOn ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual void | LazyEvaluationOff ()
| Most Locators build their search structures during BuildLocator but some may delay construction until it is actually needed. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, double pcoords[3], double *weights)
| Find the cell containing a given point. More...
virtual vtkIdType | FindCell (double x[3], double tol2, vtkGenericCell *GenCell, int &subId, double pcoords[3], double *weights)
| Find the cell containing a given point. More...
Public Member Functions inherited from vtkLocator
virtual void | Update ()
| Cause the locator to rebuild itself if it or its input dataset has changed. More...
virtual void | Initialize ()
| Initialize locator. More...
virtual void | SetDataSet (vtkDataSet *)
| Build the locator from the points/cells defining this dataset. More...
virtual vtkDataSet * | GetDataSet ()
| Build the locator from the points/cells defining this dataset. More...
virtual void | SetMaxLevel (int)
| Set the maximum allowable level for the tree. More...
virtual int | GetMaxLevel ()
| Set the maximum allowable level for the tree. More...
virtual int | GetLevel ()
| Get the level of the locator (determined automatically if Automatic is true). More...
virtual void | SetAutomatic (vtkTypeBool)
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual vtkTypeBool | GetAutomatic ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOn ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOff ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | SetTolerance (double)
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual double | GetTolerance ()
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual void | SetUseExistingSearchStructure (vtkTypeBool)
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkTypeBool | GetUseExistingSearchStructure ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOn ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOff ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkMTimeType | GetBuildTime ()
| Return the time of the last data structure build. More...
bool | UsesGarbageCollector () const override
| Handle the PointSet <-> Locator loop. More...
vtkLocator * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkOBBTree * | New ()
| Construct with automatic computation of divisions, averaging 25 cells per octant. More...
static void | ComputeOBB (vtkPoints *pts, double corner[3], double max[3], double mid[3], double min[3], double size[3])
| Compute an OBB from the list of points given. More...
Static Public Member Functions inherited from vtkAbstractCellLocator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractCellLocator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkLocator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkLocator * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkOBBTree ()
| ~vtkOBBTree () override
void | BuildLocatorInternal () override
| This function is not pure virtual to maintain backwards compatibility. More...
void | ComputeOBB (vtkIdList *cells, double corner[3], double max[3], double mid[3], double min[3], double size[3])
void | BuildTree (vtkIdList *cells, vtkOBBNode *parent, int level)
void | DeleteTree (vtkOBBNode *OBBptr)
void | GeneratePolygons (vtkOBBNode *OBBptr, int level, int repLevel, vtkPoints *pts, vtkCellArray *polys)
Protected Member Functions inherited from vtkAbstractCellLocator
| vtkAbstractCellLocator ()
| ~vtkAbstractCellLocator () override
void | UpdateInternalWeights ()
| To be called in `FindCell(double[3])`. More...
void | GetCellBounds (vtkIdType cellId, double *&cellBoundsPtr)
virtual bool | StoreCellBounds ()
| This command is used internally by the locator to copy all cell Bounds into the internal CellBounds array. More...
virtual void | FreeCellBounds ()
| This command is used internally by the locator to copy all cell Bounds into the internal CellBounds array. More...
Protected Member Functions inherited from vtkLocator
| vtkLocator ()
| ~vtkLocator () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkOBBNode * | Tree
vtkPoints * | PointsList
int * | InsertedPoints
int | OBBCount
Protected Attributes inherited from vtkAbstractCellLocator
int | NumberOfCellsPerNode
vtkTypeBool | RetainCellLists
vtkTypeBool | CacheCellBounds
vtkNew< vtkGenericCell > | GenericCell
std::shared_ptr< std::vector< double > > | CellBoundsSharedPtr
double * | CellBounds
vtkTimeStamp | WeightsTime
| This time stamp helps us decide if we want to update internal `Weights` array size. More...
std::vector< double > | Weights
| This array is resized so that it can fit points from the cell hosting the most in the input data set. More...
Protected Attributes inherited from vtkLocator
vtkDataSet * | DataSet
vtkTypeBool | UseExistingSearchStructure
vtkTypeBool | Automatic
double | Tolerance
int | MaxLevel
int | Level
vtkTimeStamp | BuildTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkAbstractCellLocator | Superclass
| Standard methods to print and obtain type-related information. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods to print and obtain type-related information. More...
static vtkOBBTree * | SafeDownCast (vtkObjectBase *o)
| Standard methods to print and obtain type-related information. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods to print and obtain type-related information. More...
vtkOBBTree * | NewInstance () const
| Standard methods to print and obtain type-related information. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods to print and obtain type-related information. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods to print and obtain type-related information. More...

## Additional Inherited Members
Public Types inherited from vtkAbstractCellLocator
typedef vtkLocator | Superclass
Public Types inherited from vtkLocator
typedef vtkObject | Superclass
| Standard type and print methods. More...
Static Protected Member Functions inherited from vtkAbstractCellLocator
static bool | IsInBounds (const double bounds[6], const double x[3], double tol=0.0)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

generate oriented bounding box (OBB) tree

vtkOBBTree is an object to generate oriented bounding box (OBB) trees. An oriented bounding box is a bounding box that does not necessarily line up along coordinate axes. The OBB tree is a hierarchical tree structure of such boxes, where deeper levels of OBB confine smaller regions of space.

To build the OBB, a recursive, top-down process is used. First, the root OBB is constructed by finding the mean and covariance matrix of the cells (and their points) that define the dataset. The eigenvectors of the covariance matrix are extracted, giving a set of three orthogonal vectors that define the tightest-fitting OBB. To create the two children OBB's, a split plane is found that (approximately) divides the number cells in half. These are then assigned to the children OBB's. This process then continues until the MaxLevel ivar limits the recursion, or no split plane can be found.

A good reference for OBB-trees is Gottschalk & Manocha in Proceedings of Siggraph `96.

Warning
  vtkOBBTree utilizes the following parent class parameters:
  - Tolerance (default 0.01)
  - Level (default 4)
  - MaxLevel (default 12)
  - NumberOfCellsPerNode (default 32)
  - RetainCellLists (default true)
  - UseExistingSearchStructure (default false)

vtkOBBTree does NOT utilize the following parameters:

- Automatic
- CacheCellBounds

Warning
  Since this algorithms works from a list of cells, the OBB tree will only bound the "geometry" attached to the cells if the convex hull of the cells bounds the geometry.
  Long, skinny cells (i.e., cells with poor aspect ratio) may cause unsatisfactory results. This is due to the fact that this is a top-down implementation of the OBB tree, requiring that one or more complete cells are contained in each OBB. This requirement makes it hard to find good split planes during the recursion process. A bottom-up implementation would go a long way to correcting this problem.

See also
  vtkAbstractCellLocator vtkCellLocator vtkStaticCellLocator vtkCellTreeLocator vtkModifiedBSPTree

Online Examples:

Tests:
  vtkOBBTree (Tests)

Definition at line 94 of file vtkOBBTree.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractCellLocator vtkOBBTree::Superclass

Standard methods to print and obtain type-related information.

Definition at line 101 of file vtkOBBTree.h.

## Constructor & Destructor Documentation

## ◆ vtkOBBTree()

vtkOBBTree::vtkOBBTree | ( |  | ) |
| protected

## ◆ ~vtkOBBTree()

vtkOBBTree::~vtkOBBTree | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkOBBTree::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods to print and obtain type-related information.

## ◆ IsA()

virtual vtkTypeBool vtkOBBTree::IsA | ( | const char * | type | ) |
| virtual

Standard methods to print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ SafeDownCast()

static vtkOBBTree* vtkOBBTree::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods to print and obtain type-related information.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOBBTree::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods to print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ NewInstance()

vtkOBBTree* vtkOBBTree::NewInstance | ( |  | ) | const

Standard methods to print and obtain type-related information.

## ◆ PrintSelf()

void vtkOBBTree::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods to print and obtain type-related information.

Reimplemented from vtkAbstractCellLocator.

## ◆ New()

static vtkOBBTree* vtkOBBTree::New | ( |  | ) |
| static

Construct with automatic computation of divisions, averaging 25 cells per octant.

## ◆ IntersectWithLine() [1/8]

int vtkOBBTree::IntersectWithLine | ( | const double | a0[3],
|  | const double | a1[3],
|  | double | tol,
|  | double & | t,
|  | double | x[3],
|  | double | pcoords[3],
|  | int & | subId,
|  | vtkIdType & | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Return the first intersection of the specified line segment with the OBB tree, as well as information about the cell which the line segment intersected.

A return value of 1 indicates an intersection and 0 indicates no intersection.

Reimplemented from vtkAbstractCellLocator.

## ◆ IntersectWithLine() [2/8]

int vtkOBBTree::IntersectWithLine | ( | const double | a0[3],
|  | const double | a1[3],
|  | vtkPoints * | points,
|  | vtkIdList * | cellIds
| ) |  |
| overridevirtual

Take the passed line segment and intersect it with the data set.

This method assumes that the data set is a vtkPolyData that describes a closed surface, and the intersection points that are returned in 'points' alternate between entrance points and exit points. The return value of the function is 0 if no intersections were found, -1 if point 'a0' lies inside the closed surface, or +1 if point 'a0' lies outside the closed surface. Either 'points' or 'cellIds' can be set to nullptr if you don't want to receive that information.

Reimplemented from vtkAbstractCellLocator.

## ◆ ComputeOBB() [1/3]

static void vtkOBBTree::ComputeOBB | ( | vtkPoints * | pts,
|  | double | corner[3],
|  | double | max[3],
|  | double | mid[3],
|  | double | min[3],
|  | double | size[3]
| ) |  |
| static

Compute an OBB from the list of points given.

Return the corner point and the three axes defining the orientation of the OBB. Also return a sorted list of relative "sizes" of axes for comparison purposes.

## ◆ ComputeOBB() [2/3]

void vtkOBBTree::ComputeOBB | ( | vtkDataSet * | input,
|  | double | corner[3],
|  | double | max[3],
|  | double | mid[3],
|  | double | min[3],
|  | double | size[3]
| ) |  |

Compute an OBB for the input dataset using the cells in the data.

Return the corner point and the three axes defining the orientation of the OBB. Also return a sorted list of relative "sizes" of axes for comparison purposes.

## ◆ InsideOrOutside()

int vtkOBBTree::InsideOrOutside | ( | const double | point[3] | ) |

Determine whether a point is inside or outside the data used to build this OBB tree.

The data must be a closed surface vtkPolyData data set. The return value is +1 if outside, -1 if inside, and 0 if undecided.

## ◆ DisjointOBBNodes()

int vtkOBBTree::DisjointOBBNodes | ( | vtkOBBNode * | nodeA,
|  | vtkOBBNode * | nodeB,
|  | vtkMatrix4x4 * | XformBtoA
| ) |  |

Returns true if nodeB and nodeA are disjoint after optional transformation of nodeB with matrix XformBtoA.

## ◆ LineIntersectsNode()

int vtkOBBTree::LineIntersectsNode | ( | vtkOBBNode * | pA,
|  | const double | b0[3],
|  | const double | b1[3]
| ) |  |

Returns true if line intersects node.

## ◆ TriangleIntersectsNode()

int vtkOBBTree::TriangleIntersectsNode | ( | vtkOBBNode * | pA,
|  | double | p0[3],
|  | double | p1[3],
|  | double | p2[3],
|  | vtkMatrix4x4 * | XformBtoA
| ) |  |

Returns true if triangle (optionally transformed) intersects node.

## ◆ IntersectWithOBBTree()

int vtkOBBTree::IntersectWithOBBTree | ( | vtkOBBTree * | OBBTreeB,
|  | vtkMatrix4x4 * | XformBtoA,
|  | int(*)(vtkOBBNode *nodeA, vtkOBBNode *nodeB, vtkMatrix4x4 *Xform, void *arg) | function,
|  | void * | data_arg
| ) |  |

For each intersecting leaf node pair, call function.

OBBTreeB is optionally transformed by XformBtoA before testing.

## ◆ FreeSearchStructure()

void vtkOBBTree::FreeSearchStructure | ( |  | ) |
| overridevirtual

Satisfy locator's abstract interface, see vtkLocator.

Implements vtkLocator.

## ◆ BuildLocator()

void vtkOBBTree::BuildLocator | ( |  | ) |
| overridevirtual

Satisfy locator's abstract interface, see vtkLocator.

Implements vtkLocator.

## ◆ ForceBuildLocator()

void vtkOBBTree::ForceBuildLocator | ( |  | ) |
| overridevirtual

Satisfy locator's abstract interface, see vtkLocator.

Reimplemented from vtkLocator.

## ◆ GenerateRepresentation()

void vtkOBBTree::GenerateRepresentation | ( | int | level,
|  | vtkPolyData * | pd
| ) |  |
| overridevirtual

Create polygonal representation for OBB tree at specified level.

If level < 0, then the leaf OBB nodes will be gathered. The aspect ratio (ar) and line diameter (d) are used to control the building of the representation. If a OBB node edge ratio's are greater than ar, then the dimension of the OBB is collapsed (OBB->plane->line). A "line" OBB will be represented either as two crossed polygons, or as a line, depending on the relative diameter of the OBB compared to the diameter (d).

Implements vtkLocator.

## ◆ BuildLocatorInternal()

void vtkOBBTree::BuildLocatorInternal | ( |  | ) |
| overrideprotectedvirtual

This function is not pure virtual to maintain backwards compatibility.

Reimplemented from vtkLocator.

## ◆ ComputeOBB() [3/3]

void vtkOBBTree::ComputeOBB | ( | vtkIdList * | cells,
|  | double | corner[3],
|  | double | max[3],
|  | double | mid[3],
|  | double | min[3],
|  | double | size[3]
| ) |  |
| protected

## ◆ BuildTree()

void vtkOBBTree::BuildTree | ( | vtkIdList * | cells,
|  | vtkOBBNode * | parent,
|  | int | level
| ) |  |
| protected

## ◆ DeleteTree()

void vtkOBBTree::DeleteTree | ( | vtkOBBNode * | OBBptr | ) |
| protected

## ◆ GeneratePolygons()

void vtkOBBTree::GeneratePolygons | ( | vtkOBBNode * | OBBptr,
|  | int | level,
|  | int | repLevel,
|  | vtkPoints * | pts,
|  | vtkCellArray * | polys
| ) |  |
| protected

## ◆ IntersectWithLine() [3/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) of finite line with cells contained in cell locator.

See vtkCell.h parameters documentation.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [4/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) AND the cell which was intersected by the finite line.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [5/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Return intersection point (if any) AND the cell which was intersected by the finite line.

The cell is returned as a cell id and as a generic cell.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## ◆ IntersectWithLine() [6/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found, -1 if point 'a0' lies inside the closed surface, or +1 if point 'a0' lies outside the closed surface. This method assumes that the data set is a vtkPolyData that describes a closed surface, and the intersection points that are returned in 'points' alternate between entrance points and exit points.

Either 'points' or 'cellIds' can be set to nullptr if you don't want to receive that information.

This method is only implemented in vtkOBBTree.

THIS FUNCTION IS THREAD SAFE.

## ◆ IntersectWithLine() [7/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found. For each intersection with a cell, the points and cellIds have the relevant information added sorted by t. If points or cellIds are nullptr pointers, then no information is generated for that list.

THIS FUNCTION IS NOT THREAD SAFE.

## ◆ IntersectWithLine() [8/8]

virtual int vtkAbstractCellLocator::IntersectWithLine

Take the passed line segment and intersect it with the data set.

The return value of the function is 0 if no intersections were found. For each intersection with the bounds of a cell or with a cell (if a cell is provided), the points and cellIds have the relevant information added sorted by t. If points or cellIds are nullptr pointers, then no information is generated for that list.

This function takes in a vtkGenericCell to avoid using the internal vtkGenericCell.

THIS FUNCTION IS THREAD SAFE.

## Member Data Documentation

## ◆ Tree

vtkOBBNode* vtkOBBTree::Tree
| protected

Definition at line 218 of file vtkOBBTree.h.

## ◆ PointsList

vtkPoints* vtkOBBTree::PointsList
| protected

Definition at line 220 of file vtkOBBTree.h.

## ◆ InsertedPoints

int* vtkOBBTree::InsertedPoints
| protected

Definition at line 221 of file vtkOBBTree.h.

## ◆ OBBCount

int vtkOBBTree::OBBCount
| protected

Definition at line 222 of file vtkOBBTree.h.

The documentation for this class was generated from the following file:

- Filters/General/vtkOBBTree.h